## ns3 3.47

=== CMakeLists.txt ===
# ##############################################################################
# Required CMake version            #
# ##############################################################################
cmake_minimum_required(VERSION 3.20..3.20)

# ##############################################################################
# Project name                        #
# ##############################################################################
project(NS3 CXX)

file(STRINGS VERSION NS3_VER)

# minimum compiler versions
set(AppleClang_MinVersion 15.0.0)
set(Clang_MinVersion 17.0.0)
set(GNU_MinVersion 11.0.0)

# common options
option(NS3_ASSERT "Enable assert on failure" OFF)
option(NS3_DES_METRICS "Enable DES Metrics event collection" OFF)
option(NS3_EXAMPLES "Enable examples to be built" OFF)
option(NS3_LOG "Enable logging to be built" OFF)
option(NS3_TESTS "Enable tests to be built" OFF)

# fd-net-device options
option(NS3_EMU "Build with emulation support" ON)
option(NS3_TAP "Build with Tap support" ON)
option(NS3_DPDK "Enable fd-net-device DPDK features" OFF)

# maintenance and documentation
option(NS3_CLANG_FORMAT "Enforce cody style with clang-format" OFF)
option(NS3_CLANG_TIDY "Use clang-tidy static analysis" OFF)
option(NS3_CLANG_TIDY_FIX
       "Use clang-tidy static analysis and apply automatic fixes" OFF
)
option(NS3_CLANG_TIMETRACE
       "Collect compilation statistics to analyze the build process" OFF
)
option(NS3_COLORED_OUTPUT "Colorize CMake messages" OFF)
option(NS3_COVERAGE "Enable code coverage measurements and report generation"
       OFF
)
option(NS3_COVERAGE_ZERO_COUNTERS
       "Zero lcov counters before running. Requires NS3_COVERAGE=ON" OFF
)
option(NS3_INCLUDE_WHAT_YOU_USE
       "Use IWYU to determine unnecessary headers included" OFF
)
option(NS3_LINK_WHAT_YOU_USE
       "Use LWYU to determine unnecessary linked libraries" OFF
)
option(NS3_SANITIZE "Build with address, leak and undefined sanitizers" OFF)
option(NS3_SANITIZE_MEMORY "Build with memory sanitizer" OFF)

# 3rd-party libraries/programs
option(NS3_NETANIM "Build netanim" OFF)

# other options
option(NS3_ENABLE_BUILD_VERSION "Embed version info into libraries" OFF)
option(NS3_CCACHE "Use Ccache to speed up recompilation" ON)
option(NS3_CPM "Enable the CPM C++ library manager support" OFF)
option(NS3_FAST_LINKERS "Use Mold or LLD to speed up linking if available" ON)
option(NS3_FETCH_OPTIONAL_COMPONENTS
       "Fetch Brite, Click and Openflow dependencies" OFF
)
option(
  NS3_FORCE_LOCAL_DEPENDENCIES
  "Only search applications, headers, libraries on explicitly set directories"
  OFF
)
option(NS3_GSL "Build with GSL support" ON)
option(NS3_GTK3 "Build with GTK3 support" ON)
option(NS3_LINK_TIME_OPTIMIZATION "Build with link-time optimization" OFF)
option(NS3_MONOLIB
       "Build a single shared ns-3 library and link it against executables" OFF
)
option(NS3_MPI "Build with MPI support" OFF)
option(NS3_NATIVE_OPTIMIZATIONS "Build with -march=native -mtune=native" OFF)
option(
  NS3_NINJA_TRACING
  "Use ninjatracing to convert Ninja's build log to the about://tracing format"
  OFF
)
set(NS3_OUTPUT_DIRECTORY "" CACHE STRING "Directory to store built artifacts")
option(NS3_PRECOMPILE_HEADERS
       "Precompile module headers to speed up compilation" ON
)
option(NS3_PYTHON_BINDINGS "Build ns-3 python bindings" OFF)
option(NS3_SQLITE "Build with SQLite support" ON)
option(NS3_EIGEN "Build with Eigen support" ON)
option(NS3_STATIC "Build a static ns-3 library and link it against executables"
       OFF
)
option(NS3_VCPKG "Enable the Vcpkg C++ library manager support" OFF)
option(NS3_VERBOSE "Print additional build system messages" OFF)
option(NS3_VISUALIZER "Build visualizer module" ON)
option(NS3_WARNINGS "Enable compiler warnings" ON)
option(NS3_WARNINGS_AS_ERRORS
       "Treat warnings as errors. Requires NS3_WARNINGS=ON" ON
)

# Options that either select which modules will get built or disable modules
set(NS3_ENABLED_MODULES ""
    CACHE STRING "List of modules to enable (e.g. core;network;internet)"
)
set(NS3_DISABLED_MODULES "" CACHE STRING
                                  "List of modules to disable (e.g. lte;wifi)"
)

# Filter in the modules from which examples and tests will be built
set(NS3_FILTER_MODULE_EXAMPLES_AND_TESTS
    ""
    CACHE
      STRING
      "List of modules that should have their examples and tests built (e.g. lte;wifi)"
)

# Include macros used below
include(build-support/macros-and-definitions.cmake)

# Scan module libraries
subdirlist(libs_to_build ${CMAKE_CURRENT_SOURCE_DIR}/src)

# Scan contribution libraries
subdirlist(contrib_libs_to_build ${CMAKE_CURRENT_SOURCE_DIR}/contrib)

# Scan for additional contribution libraries OUTSIDE the ns-3 source directory,
# in the ns-3-external-contrib directory
if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../ns-3-external-contrib)
  subdirlist(
    external_contrib_libs_to_build
    ${CMAKE_CURRENT_SOURCE_DIR}/../ns-3-external-contrib
  )
  set(contrib_libs_to_build ${contrib_libs_to_build}
                            ${external_contrib_libs_to_build}
  )
endif()

# Before filtering, we need to load settings from .ns3rc
parse_ns3rc(
  ns3rc_enabled_modules ns3rc_disabled_modules ns3rc_examples_enabled
  ns3rc_tests_enabled
)

# After scanning modules, we can filter enabled and disabled ones
filter_enabled_and_disabled_modules(
  libs_to_build contrib_libs_to_build NS3_ENABLED_MODULES NS3_DISABLED_MODULES
  ns3rc_enabled_modules ns3rc_disabled_modules
)

if(${NS3_CCACHE})
  # Use ccache if available
  mark_as_advanced(CCACHE)
  find_program(CCACHE ccache)
  if(NOT ("${CCACHE}" STREQUAL "CCACHE-NOTFOUND"))
    message(STATUS "CCache is enabled.")
    set(CMAKE_CXX_COMPILER_LAUNCHER ${CCACHE})
    execute_process(
      COMMAND
        ${CCACHE} --set-config
        sloppiness=pch_defines,time_macros,include_file_mtime,include_file_ctime
    )
    if(DEFINED MSVC)
      if(MSVC)
        file(COPY_FILE ${CCACHE} ${CMAKE_BINARY_DIR}/clang-cl.exe
             ONLY_IF_DIFFERENT
        )
        set(CMAKE_VS_GLOBALS
            "CLToolExe=clang-cl.exe" "CLToolPath=${CMAKE_BINARY_DIR}"
            "TrackFileAccess=false" "UseMultiToolTask=true"
            "DebugInformationFormat=OldStyle"
        )
      endif()
    endif()
  endif()
endif()

# ##############################################################################
# Process options                     #
# ##############################################################################
process_options()

# ##############################################################################
# Add subdirectories                  #
# ##############################################################################
# Build NS3 library core
add_subdirectory(src)

# Build NS library examples
add_subdirectory(examples)

# Build scratch/simulation scripts
add_subdirectory(scratch)

# Build test utils
add_subdirectory(utils)

write_lock()
write_configtable()

# Export package targets when installing
ns3_cmake_package()

=== doc/models/Makefile ===
include $(CURDIR)/../sphinx/defines.mk

SRC = ../../src
# Temporary source directory, for build
SOURCETEMP = source-temp
FIGURES = $(SOURCETEMP)/figures

# list all model library .rst files that need to be copied to $SOURCETEMP
SOURCES = \
	source/conf.py \
	source/_static \
	source/index.rst \
	source/replace.txt \
	source/organization.rst \
	source/internet-models.rst \
	source/network.rst \
	source/emulation-overview.rst \
	source/traffic-control.rst \
	$(SRC)/antenna/doc/antenna.rst \
	$(SRC)/aodv/doc/aodv.rst \
	$(SRC)/applications/doc/applications.rst \
        $(SRC)/applications/doc/rta-tig-mobile-gaming-traffic.inc \
        $(SRC)/applications/doc/tgax-video-traffic.inc \
        $(SRC)/applications/doc/tgax-virtual-desktop-traffic.inc \
        $(SRC)/applications/doc/tgax-voip-traffic.inc \
	$(SRC)/bridge/doc/bridge.rst \
	$(SRC)/brite/doc/brite.rst \
	$(SRC)/buildings/doc/source/buildings.rst \
	$(SRC)/buildings/doc/source/buildings-design.rst \
	$(SRC)/buildings/doc/source/buildings-user.rst \
	$(SRC)/buildings/doc/source/buildings-testing.rst \
	$(SRC)/buildings/doc/source/buildings-references.rst \
	$(SRC)/click/doc/click.rst \
	$(SRC)/csma/doc/csma.rst \
	$(SRC)/dsdv/doc/dsdv.rst \
	$(SRC)/dsr/doc/dsr.rst \
	$(SRC)/mpi/doc/distributed.rst \
	$(SRC)/energy/doc/energy.rst \
	$(SRC)/fd-net-device/doc/fd-net-device.rst \
	$(SRC)/fd-net-device/doc/dpdk-net-device.rst \
	$(SRC)/fd-net-device/doc/netmap-net-device.rst \
	$(SRC)/tap-bridge/doc/tap.rst \
	$(SRC)/mesh/doc/source/mesh.rst \
	$(SRC)/mesh/doc/source/mesh-user.rst \
	$(SRC)/mesh/doc/source/mesh-design.rst \
	$(SRC)/mesh/doc/source/mesh-references.rst \
	$(SRC)/mesh/doc/source/mesh-testing.rst \
	$(SRC)/lte/doc/source/lte.rst \
	$(SRC)/lte/doc/source/lte-user.rst \
	$(SRC)/lte/doc/source/lte-design.rst \
	$(SRC)/lte/doc/source/lte-testing.rst \
	$(SRC)/lte/doc/source/lte-profiling.rst \
	$(SRC)/lte/doc/source/lte-references.rst \
	$(SRC)/propagation/doc/propagation.rst \
	$(SRC)/network/doc/network-overview.rst \
	$(SRC)/network/doc/packets.rst \
	$(SRC)/network/doc/error-model.rst \
	$(SRC)/network/doc/sockets-api.rst \
	$(SRC)/network/doc/simple.rst \
	$(SRC)/network/doc/queue.rst \
	$(SRC)/network/doc/queue-limits.rst \
	$(SRC)/nix-vector-routing/doc/nix-vector-routing.rst \
	$(SRC)/internet/doc/internet-stack.rst \
	$(SRC)/internet/doc/ipv4.rst \
	$(SRC)/internet/doc/ipv6.rst \
	$(SRC)/internet/doc/routing-overview.rst \
	$(SRC)/internet/doc/global-routing.rst \
	$(SRC)/internet/doc/tcp.rst \
	$(SRC)/internet/doc/udp.rst \
	$(SRC)/internet-apps/doc/internet-apps.rst \
	$(SRC)/mobility/doc/mobility.rst \
	$(SRC)/olsr/doc/olsr.rst \
	$(SRC)/openflow/doc/openflow-switch.rst \
	$(SRC)/point-to-point/doc/point-to-point.rst \
	$(SRC)/wifi/doc/source/wifi.rst \
	$(SRC)/wifi/doc/source/wifi-design.rst \
	$(SRC)/wifi/doc/source/wifi-user.rst \
	$(SRC)/wifi/doc/source/wifi-testing.rst \
	$(SRC)/wifi/doc/source/wifi-changelog.rst \
	$(SRC)/wifi/doc/source/wifi-references.rst \
	$(SRC)/uan/doc/uan.rst \
	$(SRC)/topology-read/doc/topology.rst \
	$(SRC)/traffic-control/doc/traffic-control-layer.rst \
	$(SRC)/traffic-control/doc/queue-discs.rst \
	$(SRC)/traffic-control/doc/pfifo-fast.rst \
	$(SRC)/traffic-control/doc/fifo.rst \
	$(SRC)/traffic-control/doc/prio.rst \
	$(SRC)/traffic-control/doc/tbf.rst \
	$(SRC)/traffic-control/doc/red.rst \
	$(SRC)/traffic-control/doc/codel.rst \
	$(SRC)/traffic-control/doc/cobalt.rst \
	$(SRC)/traffic-control/doc/fq-codel.rst \
	$(SRC)/traffic-control/doc/fq-cobalt.rst \
	$(SRC)/traffic-control/doc/pie.rst \
	$(SRC)/traffic-control/doc/fq-pie.rst \
	$(SRC)/traffic-control/doc/mq.rst \
	$(SRC)/spectrum/doc/spectrum.rst \
	$(SRC)/netanim/doc/animation.rst \
	$(SRC)/flow-monitor/doc/flow-monitor.rst \
	$(SRC)/sixlowpan/doc/sixlowpan.rst \
	$(SRC)/lr-wpan/doc/lr-wpan.rst \
	$(SRC)/zigbee/doc/zigbee.rst \

# list all model library figure files that need to be copied to
# $SOURCETEMP/figures.  For each figure to be included in all
# documentation formats (html, latex...) the following formats are supported:
#  1) a single .dia file (preferred option, because it can be edited)
#  2) a single .eps file
#  3) a single .png file
#  4) both a .pdf and .png file
SOURCEFIGS = \
	figures/testbed.dia \
	figures/emulated-channel.dia \
	$(SRC)/antenna/doc/figures/antenna-coordinate-system.dia	\
	$(SRC)/antenna/doc/figures/circular-antenna-pattern.png	\
	$(SRC)/applications/doc/http-embedded-object-size.png \
	$(SRC)/applications/doc/http-main-object-size.png \
	$(SRC)/applications/doc/http-num-of-embedded-objects.png \
	$(SRC)/applications/doc/http-parsing-time.png \
	$(SRC)/applications/doc/http-reading-time.png \
	$(SRC)/dsr/doc/figures/dsrRreq.dia \
	$(SRC)/dsr/doc/figures/dsrRrep.dia \
	$(SRC)/network/doc/packet.dia \
	$(SRC)/network/doc/node.dia \
	$(SRC)/network/doc/buffer.dia \
	$(SRC)/network/doc/sockets-overview.dia \
	$(SRC)/internet/doc/internet-node-send.dia \
	$(SRC)/internet/doc/internet-node-recv.dia \
	$(SRC)/internet/doc/routing.dia \
	$(SRC)/internet/doc/routing-specialization.dia \
	$(SRC)/internet/doc/global-routing-limitation.dia \
	$(SRC)/internet/doc/figures/tcp-state-machine.png \
	$(SRC)/internet/doc/figures/fack-cwnd.png \
	$(SRC)/internet/doc/figures/fack-inflight.png \
	$(SRC)/internet/doc/figures/fack-packetDrops.png \
	$(SRC)/internet/doc/figures/fack-throughput.png\
	$(SRC)/internet/doc/figures/dctcp-10ms-50mbps-tcp-throughput.pdf \
	$(SRC)/internet/doc/figures/dctcp-10ms-50mbps-tcp-throughput.png \
	$(SRC)/internet/doc/figures/dctcp-80ms-50mbps-tcp-throughput.pdf \
	$(SRC)/internet/doc/figures/dctcp-80ms-50mbps-tcp-throughput.png \
	$(SRC)/internet/doc/figures/cubic-50ms-50mbps-tcp-cwnd-no-ecn.pdf \
	$(SRC)/internet/doc/figures/cubic-50ms-50mbps-tcp-cwnd-no-ecn.png \
	$(SRC)/internet/doc/figures/cubic-50ms-50mbps-tcp-cwnd-ecn.pdf \
	$(SRC)/internet/doc/figures/cubic-50ms-50mbps-tcp-cwnd-ecn.png \
	$(SRC)/internet/doc/figures/dce-linux-reno-vs-ns3-linux-reno.png \
	$(SRC)/internet/doc/figures/dce-linux-reno-vs-ns3-new-reno.png \
	$(SRC)/internet/doc/figures/ns3-new-reno-vs-ns3-linux-reno.png \
	$(SRC)/internet/doc/figures/ns3-bbr-vs-linux-bbr.png \
	$(SRC)/wifi/doc/source/figures/WifiArchitecture.dia \
	$(SRC)/wifi/doc/source/figures/PhyEntityHierarchy.dia \
	$(SRC)/wifi/doc/source/figures/WifiPpduHierarchy.dia \
	$(SRC)/wifi/doc/source/figures/FemHierarchy.dia \
	$(SRC)/wifi/doc/source/figures/wifi-phy-rx-trace-helper.dia \
	$(SRC)/wifi/doc/source/figures/snir.dia \
	$(SRC)/wifi/doc/source/figures/ack-su-format.pdf \
	$(SRC)/wifi/doc/source/figures/ack-su-format.png \
	$(SRC)/wifi/doc/source/figures/assoc-manager.eps \
	$(SRC)/wifi/doc/source/figures/emlsr-dl-txop.eps \
	$(SRC)/wifi/doc/source/figures/emlsr-txop-ended-trace.eps \
	$(SRC)/wifi/doc/source/figures/emlsr-ul-txop.eps \
	$(SRC)/wifi/doc/source/figures/mu-bar.pdf \
	$(SRC)/wifi/doc/source/figures/mu-bar.png \
	$(SRC)/wifi/doc/source/figures/aggr-mu-bar.pdf \
	$(SRC)/wifi/doc/source/figures/aggr-mu-bar.png \
	$(SRC)/wifi/doc/source/figures/ul-ofdma.pdf \
	$(SRC)/wifi/doc/source/figures/ul-ofdma.png \
	$(SRC)/wifi/doc/source/figures/clear-channel.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate-n.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate-ac.eps \
	$(SRC)/wifi/doc/source/figures/nist-frame-success-rate-ax.eps \
	$(SRC)/wifi/doc/source/figures/wifi-11a-p-1500-adhoc-r-54-min-5-max-50-step-5-throughput.eps \
	$(SRC)/wifi/doc/source/figures/wifi-11g-p-1500-infrastructure-r-6-min-5-max-50-step-5-throughput.eps \
	$(SRC)/wifi/doc/source/figures/default-table-based-error-model-validation.eps \
	$(SRC)/wifi/doc/source/figures/error-models-comparison.eps \
	$(SRC)/wifi/doc/source/figures/spectrum-wifi-phy-multiple-interfaces.pdf \
	$(SRC)/wifi/doc/source/figures/spectrum-wifi-phy-multiple-interfaces.png \
	$(SRC)/wifi/doc/source/figures/cca-channel-switching-multiple-interfaces.pdf \
	$(SRC)/wifi/doc/source/figures/cca-channel-switching-multiple-interfaces.png \
	$(SRC)/lte/doc/source/figures/epc-ctrl-arch.dia \
	$(SRC)/lte/doc/source/figures/epc-data-flow-dl.dia \
	$(SRC)/lte/doc/source/figures/epc-data-flow-dl-with-split.dia \
	$(SRC)/lte/doc/source/figures/epc-data-flow-ul.dia \
	$(SRC)/lte/doc/source/figures/epc-data-flow-ul-with-split.dia \
	$(SRC)/lte/doc/source/figures/epc-profiling-scenario.dia \
	$(SRC)/lte/doc/source/figures/epc-topology.dia \
	$(SRC)/lte/doc/source/figures/epc-topology-with-split.dia \
	$(SRC)/lte/doc/source/figures/epc-topology-x2-enhanced.dia \
	$(SRC)/lte/doc/source/figures/eutran-profiling-scenario.dia \
	$(SRC)/lte/doc/source/figures/ff-example.dia \
	$(SRC)/lte/doc/source/figures/ff-mac-saps.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-enb-data.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-enb-ctrl.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-ue-data.dia \
	$(SRC)/lte/doc/source/figures/lte-arch-ue-ctrl.dia \
	$(SRC)/lte/doc/source/figures/lte-enb-phy.dia \
	$(SRC)/lte/doc/source/figures/lte-ue-phy.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-x2-handover-seq-diagram.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-e2e-data-protocol-stack.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-e2e-data-protocol-stack-with-split.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-e2e-control-protocol-stack-with-split.dia \
	$(SRC)/lte/doc/source/figures/lte-interference-test-scenario.dia \
	$(SRC)/lte/doc/source/figures/lte-subframe-structure.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-x2-interface.dia \
	$(SRC)/lte/doc/source/figures/lte-harq-architecture.dia \
	$(SRC)/lte/doc/source/figures/lte-harq-processes-scheme.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-consumer.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-piecewise-motion.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-piecewise-a1.dia \
	$(SRC)/lte/doc/source/figures/ue-meas-piecewise-a1-hys.dia \
	$(SRC)/lte/doc/source/figures/lte-cell-selection-timeline.dia \
	$(SRC)/lte/doc/source/figures/lte-cell-selection-scenario.dia \
	$(SRC)/lte/doc/source/figures/lte-handover-target-scenario.dia \
	$(SRC)/lte/doc/source/figures/lena-dual-stripe.eps \
	$(SRC)/lte/doc/source/figures/lte-mcs-index.eps \
	$(SRC)/lte/doc/source/figures/lenaThrTestCase1.eps \
	$(SRC)/lte/doc/source/figures/lenaThrTestCase2.eps \
	$(SRC)/lte/doc/source/figures/runningTime10s.eps \
	$(SRC)/lte/doc/source/figures/epcRunningTime.eps \
	$(SRC)/lte/doc/source/figures/propagationModel.eps \
	$(SRC)/lte/doc/source/figures/simulationTime.eps \
	$(SRC)/lte/doc/source/figures/epcSimulationTime.eps \
	$(SRC)/lte/doc/source/figures/epcEutranRunningTime.eps \
	$(SRC)/lte/doc/source/figures/profiling-memory.eps \
	$(SRC)/lte/doc/source/figures/lte-rlc-implementation-model.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-txon-dl.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-retx-dl.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-txon-ul.dia \
	$(SRC)/lte/doc/source/figures/lte-rlc-data-retx-ul.dia \
	$(SRC)/lte/doc/source/figures/lte-test-rlf-one-enb.dia \
	$(SRC)/lte/doc/source/figures/lte-test-rlf-two-enb.dia \
	$(SRC)/lte/doc/source/figures/lena-radio-link-failure-one-enb.dia \
	$(SRC)/lte/doc/source/figures/lena-radio-link-failure-two-enb.dia \
	$(SRC)/lte/doc/source/figures/lte-epc-x2-entity-saps.dia \
	$(SRC)/lte/doc/source/figures/ca-rrc-reconf.dia \
	$(SRC)/lte/doc/source/figures/ca-lte-enb-net-device-changes.dia \
	$(SRC)/lte/doc/source/figures/ca-lte-ue-net-device-changes.dia \
	$(SRC)/lte/doc/source/figures/ca-enb-data-plane.dia \
	$(SRC)/lte/doc/source/figures/ca-enb-ctrl-plane.dia \
	$(SRC)/lte/doc/source/figures/ca-ue-data-plane.dia \
	$(SRC)/lte/doc/source/figures/ca-ue-ctrl-plane.dia \
	$(SRC)/lte/doc/source/figures/lte-strongest-cell-handover-algorithm.eps \
	$(SRC)/lte/doc/source/figures/lte-phy-interference.pdf \
	$(SRC)/lte/doc/source/figures/lte-phy-interference.png \
	$(SRC)/lte/doc/source/figures/helpers.pdf \
	$(SRC)/lte/doc/source/figures/helpers.png \

=== examples/tcp/CMakeLists.txt ===
build_example(
  NAME tcp-large-transfer
  SOURCE_FILES tcp-large-transfer.cc
  LIBRARIES_TO_LINK
    ${libpoint-to-point}
    ${libapplications}
    ${libinternet}
)

build_example(
  NAME tcp-star-server
  SOURCE_FILES tcp-star-server.cc
  LIBRARIES_TO_LINK
    ${libpoint-to-point}
    ${libapplications}
    ${libinternet}
)

build_example(
  NAME star
  SOURCE_FILES star.cc
  LIBRARIES_TO_LINK
    ${libnetanim}
    ${libpoint-to-point}
    ${libpoint-to-point-layout}
    ${libapplications}
    ${libinternet}
)

build_example(
  NAME tcp-ecn-example
  SOURCE_FILES tcp-ecn-example.cc
  LIBRARIES_TO_LINK
    ${libpoint-to-point}
    ${libinternet}
    ${libapplications}
    ${libtraffic-control}
    ${libnetwork}
    ${libinternet-apps}
    ${libflow-monitor}
)

build_example(
  NAME tcp-bbr-example
  SOURCE_FILES tcp-bbr-example.cc
  LIBRARIES_TO_LINK
    ${libpoint-to-point}
    ${libinternet}
    ${libapplications}
    ${libtraffic-control}
    ${libnetwork}
    ${libinternet-apps}
    ${libflow-monitor}
)

build_example(
  NAME tcp-bulk-send
  SOURCE_FILES tcp-bulk-send.cc
  LIBRARIES_TO_LINK
    ${libpoint-to-point}
    ${libapplications}
    ${libinternet}
)

build_example(
  NAME tcp-pcap-nanosec-example
  SOURCE_FILES tcp-pcap-nanosec-example.cc
  LIBRARIES_TO_LINK
    ${libpoint-to-point}
    ${libapplications}
    ${libinternet}
)

build_example(
  NAME tcp-variants-comparison
  SOURCE_FILES tcp-variants-comparison.cc
  LIBRARIES_TO_LINK
    ${libpoint-to-point}
    ${libinternet}
    ${libapplications}
    ${libflow-monitor}
)

build_example(
  NAME tcp-pacing
  SOURCE_FILES tcp-pacing.cc
  LIBRARIES_TO_LINK
    ${libpoint-to-point}
    ${libinternet}
    ${libapplications}
    ${libflow-monitor}
)

build_example(
  NAME tcp-linux-reno
  SOURCE_FILES tcp-linux-reno.cc
  LIBRARIES_TO_LINK
    ${libpoint-to-point}
    ${libinternet}
    ${libapplications}
    ${libtraffic-control}
    ${libnetwork}
)

build_example(
  NAME tcp-validation
  SOURCE_FILES tcp-validation.cc
  LIBRARIES_TO_LINK
    ${libpoint-to-point}
    ${libinternet}
    ${libapplications}
    ${libtraffic-control}
    ${libnetwork}
    ${libinternet-apps}
)

build_example(
  NAME dctcp-example
  SOURCE_FILES dctcp-example.cc
  LIBRARIES_TO_LINK
    ${libcore}
    ${libnetwork}
    ${libinternet}
    ${libpoint-to-point}
    ${libapplications}
    ${libtraffic-control}
)
build_example(
  NAME fack-example
  SOURCE_FILES fack-example.cc
  LIBRARIES_TO_LINK
    ${libinternet}
    ${libpoint-to-point}
    ${libapplications}
    ${libtraffic-control}
    ${libnetwork}
    ${libinternet-apps}
    ${libflow-monitor}
)

=== src/applications/CMakeLists.txt ===
build_lib(
  LIBNAME applications
  SOURCE_FILES
    helper/bulk-send-helper.cc
    helper/on-off-helper.cc
    helper/packet-sink-helper.cc
    helper/three-gpp-http-helper.cc
    helper/udp-client-server-helper.cc
    helper/udp-echo-helper.cc
    model/application-packet-probe.cc
    model/bulk-send-application.cc
    model/onoff-application.cc
    model/packet-loss-counter.cc
    model/packet-sink.cc
    model/rta-tig-mobile-gaming.cc
    model/seq-ts-echo-header.cc
    model/seq-ts-header.cc
    model/seq-ts-size-header.cc
    model/sink-application.cc
    model/source-application.cc
    model/tgax-video-traffic.cc
    model/tgax-virtual-desktop.cc
    model/tgax-voip-traffic.cc
    model/three-gpp-http-client.cc
    model/three-gpp-http-header.cc
    model/three-gpp-http-server.cc
    model/three-gpp-http-variables.cc
    model/udp-client.cc
    model/udp-echo-client.cc
    model/udp-echo-server.cc
    model/udp-server.cc
    model/udp-trace-client.cc
  HEADER_FILES
    helper/bulk-send-helper.h
    helper/on-off-helper.h
    helper/packet-sink-helper.h
    helper/three-gpp-http-helper.h
    helper/udp-client-server-helper.h
    helper/udp-echo-helper.h
    model/application-packet-probe.h
    model/bulk-send-application.h
    model/onoff-application.h
    model/packet-loss-counter.h
    model/packet-sink.h
    model/rta-tig-mobile-gaming.h
    model/seq-ts-echo-header.h
    model/seq-ts-header.h
    model/seq-ts-size-header.h
    model/sink-application.h
    model/source-application.h
    model/tgax-video-traffic.h
    model/tgax-virtual-desktop.h
    model/tgax-voip-traffic.h
    model/three-gpp-http-client.h
    model/three-gpp-http-header.h
    model/three-gpp-http-server.h
    model/three-gpp-http-variables.h
    model/udp-client.h
    model/udp-echo-client.h
    model/udp-echo-server.h
    model/udp-server.h
    model/udp-trace-client.h
  LIBRARIES_TO_LINK ${libinternet}
  TEST_SOURCES
    test/three-gpp-http-client-server-test.cc
    test/bulk-send-application-test-suite.cc
    test/udp-client-server-test.cc
    test/tgax-video-traffic-test-suite.cc
    test/tgax-voip-traffic-test-suite.cc
    test/tgax-virtual-desktop-test-suite.cc
    test/rta-tig-mobile-gaming-test-suite.cc
  GENERATE_EXPORT_HEADER
)

=== src/brite/CMakeLists.txt ===
set(NS3_WITH_BRITE
    ""
    CACHE PATH
          "Build with brite support"
)
set(NS3_BRITE
    "OFF"
    CACHE INTERNAL
          "ON if Brite is found in NS3_WITH_BRITE"
)

find_external_library(
  DEPENDENCY_NAME brite
  HEADER_NAME Brite.h
  LIBRARY_NAME brite
  SEARCH_PATHS ${NS3_WITH_BRITE}
  OUTPUT_VARIABLE "NS3_BRITE_REASON"
)

if((NOT
    brite_FOUND)
   AND (NOT
        ${brite_FOUND})
   AND (NOT
        ${NS3_FETCH_OPTIONAL_COMPONENTS})
)
  message(
    ${HIGHLIGHTED_STATUS}
    "Skipping src/brite"
  )
  return()
endif()

if(${NS3_FETCH_OPTIONAL_COMPONENTS})
  set(brite_LIBRARIES
      brite
  )
endif()

# Only process module if include folder and library have been found
include_directories(
  SYSTEM
  ${brite_INCLUDE_DIRS}
)
set(NS3_BRITE
    "ON"
    CACHE INTERNAL
          "ON if Brite is found in NS3_WITH_BRITE"
)

build_lib(
  LIBNAME brite
  SOURCE_FILES helper/brite-topology-helper.cc
  HEADER_FILES helper/brite-topology-helper.h
  LIBRARIES_TO_LINK
    ${libapplications}
    ${libpoint-to-point}
    ${brite_LIBRARIES}
  TEST_SOURCES test/brite-test-topology.cc
)

=== src/click/CMakeLists.txt ===
set(NS3_WITH_CLICK
    ""
    CACHE PATH
          "Build with click support"
)
set(NS3_CLICK
    "OFF"
    CACHE INTERNAL
          "ON if Click is found in NS3_WITH_CLICK"
)

find_external_library(
  DEPENDENCY_NAME click
  HEADER_NAME simclick.h
  LIBRARY_NAMES nsclick
                click
  PATH_SUFFIXES userlevel
                ns
  SEARCH_PATHS ${NS3_WITH_CLICK}
  OUTPUT_VARIABLE "NS3_CLICK_REASON"
)

if((NOT
    click_FOUND)
   AND (NOT
        ${click_FOUND})
   AND (NOT
        ${NS3_FETCH_OPTIONAL_COMPONENTS})
)
  message(
    ${HIGHLIGHTED_STATUS}
    "Skipping src/click"
  )
  return()
endif()

if(${NS3_FETCH_OPTIONAL_COMPONENTS})
  set(click_LIBRARIES
      click
      nsclick
  )
endif()

include_directories(
  SYSTEM
  ${click_INCLUDE_DIRS}
)
set(NS3_CLICK
    "ON"
    CACHE INTERNAL
          "ON if Click is found in NS3_WITH_CLICK"
)
add_definitions(-DNS3_CLICK)

build_lib(
  LIBNAME click
  SOURCE_FILES
    helper/click-internet-stack-helper.cc
    model/ipv4-click-routing.cc
    model/ipv4-l3-click-protocol.cc
  HEADER_FILES
    helper/click-internet-stack-helper.h
    model/ipv4-click-routing.h
    model/ipv4-l3-click-protocol.h
  LIBRARIES_TO_LINK ${libinternet}
                    ${click_LIBRARIES}
  TEST_SOURCES test/ipv4-click-routing-test.cc
)

=== src/internet/CMakeLists.txt ===
set(source_files
    helper/internet-stack-helper.cc
    helper/internet-trace-helper.cc
    helper/ipv4-address-helper.cc
    helper/ipv4-global-routing-helper.cc
    helper/ipv6-global-routing-helper.cc
    helper/ipv4-interface-container.cc
    helper/ipv4-list-routing-helper.cc
    helper/ipv4-routing-helper.cc
    helper/ipv4-static-routing-helper.cc
    helper/ipv6-address-helper.cc
    helper/ipv6-interface-container.cc
    helper/ipv6-list-routing-helper.cc
    helper/ipv6-routing-helper.cc
    helper/ipv6-static-routing-helper.cc
    helper/neighbor-cache-helper.cc
    helper/rip-helper.cc
    helper/ripng-helper.cc
    model/arp-cache.cc
    model/arp-header.cc
    model/arp-l3-protocol.cc
    model/arp-queue-disc-item.cc
    model/candidate-queue.cc
    model/global-route-manager-impl.cc
    model/global-route-manager.cc
    model/global-router-interface.cc
    model/icmpv4-l4-protocol.cc
    model/icmpv4.cc
    model/icmpv6-header.cc
    model/icmpv6-l4-protocol.cc
    model/ip-l4-protocol.cc
    model/ipv4-address-generator.cc
    model/ipv4-end-point-demux.cc
    model/ipv4-end-point.cc
    model/global-routing.cc
    model/ipv4-header.cc
    model/ipv4-interface-address.cc
    model/ipv4-interface.cc
    model/ipv4-l3-protocol.cc
    model/ipv4-list-routing.cc
    model/ipv4-packet-filter.cc
    model/ipv4-packet-info-tag.cc
    model/ipv4-packet-probe.cc
    model/ipv4-queue-disc-item.cc
    model/ipv4-raw-socket-factory-impl.cc
    model/ipv4-raw-socket-factory.cc
    model/ipv4-raw-socket-impl.cc
    model/ipv4-route.cc
    model/ipv4-routing-protocol.cc
    model/ipv4-routing-table-entry.cc
    model/ipv4-static-routing.cc
    model/ipv4.cc
    model/ipv6-address-generator.cc
    model/ipv6-autoconfigured-prefix.cc
    model/ipv6-end-point-demux.cc
    model/ipv6-end-point.cc
    model/ipv6-extension-demux.cc
    model/ipv6-extension-header.cc
    model/ipv6-extension.cc
    model/ipv6-header.cc
    model/ipv6-interface-address.cc
    model/ipv6-interface.cc
    model/ipv6-l3-protocol.cc
    model/ipv6-list-routing.cc
    model/ipv6-option-demux.cc
    model/ipv6-option-header.cc
    model/ipv6-option.cc
    model/ipv6-packet-filter.cc
    model/ipv6-packet-info-tag.cc
    model/ipv6-packet-probe.cc
    model/ipv6-pmtu-cache.cc
    model/ipv6-queue-disc-item.cc
    model/ipv6-raw-socket-factory-impl.cc
    model/ipv6-raw-socket-factory.cc
    model/ipv6-raw-socket-impl.cc
    model/ipv6-route.cc
    model/ipv6-routing-protocol.cc
    model/ipv6-routing-table-entry.cc
    model/ipv6-static-routing.cc
    model/ipv6.cc
    model/loopback-net-device.cc
    model/ndisc-cache.cc
    model/rip-header.cc
    model/rip.cc
    model/ripng-header.cc
    model/ripng.cc
    model/rtt-estimator.cc
    model/tcp-bbr.cc
    model/tcp-bic.cc
    model/tcp-congestion-ops.cc
    model/tcp-cubic.cc
    model/tcp-dctcp.cc
    model/tcp-header.cc
    model/tcp-highspeed.cc
    model/tcp-htcp.cc
    model/tcp-hybla.cc
    model/tcp-illinois.cc
    model/tcp-l4-protocol.cc
    model/tcp-ledbat.cc
    model/tcp-linux-reno.cc
    model/tcp-lp.cc
    model/tcp-option-rfc793.cc
    model/tcp-option-sack-permitted.cc
    model/tcp-option-sack.cc
    model/tcp-option-ts.cc
    model/tcp-option-winscale.cc
    model/tcp-option.cc
    model/tcp-prr-recovery.cc
    model/tcp-rate-ops.cc
    model/tcp-recovery-ops.cc
    model/tcp-rx-buffer.cc
    model/tcp-scalable.cc
    model/tcp-socket-base.cc
    model/tcp-socket-factory-impl.cc
    model/tcp-socket-factory.cc
    model/tcp-socket-state.cc
    model/tcp-socket.cc
    model/tcp-tx-buffer.cc
    model/tcp-tx-item.cc
    model/tcp-vegas.cc
    model/tcp-veno.cc
    model/tcp-westwood-plus.cc
    model/tcp-yeah.cc
    model/udp-header.cc
    model/udp-l4-protocol.cc
    model/udp-socket-factory-impl.cc
    model/udp-socket-factory.cc
    model/udp-socket-impl.cc
    model/udp-socket.cc
)

set(header_files
    helper/internet-stack-helper.h
    helper/internet-trace-helper.h
    helper/ipv4-address-helper.h
    helper/ipv4-global-routing-helper.h
    helper/ipv6-global-routing-helper.h
    helper/ipv4-interface-container.h
    helper/ipv4-list-routing-helper.h
    helper/ipv4-routing-helper.h
    helper/ipv4-static-routing-helper.h
    helper/ipv6-address-helper.h
    helper/ipv6-interface-container.h
    helper/ipv6-list-routing-helper.h
    helper/ipv6-routing-helper.h
    helper/ipv6-static-routing-helper.h
    helper/neighbor-cache-helper.h
    helper/rip-helper.h
    helper/ripng-helper.h
    model/arp-cache.h
    model/arp-header.h
    model/arp-l3-protocol.h
    model/arp-queue-disc-item.h
    model/candidate-queue.h
    model/global-route-manager-impl.h
    model/global-route-manager.h
    model/global-router-interface.h
    model/icmpv4-l4-protocol.h
    model/icmpv4.h
    model/icmpv6-header.h
    model/icmpv6-l4-protocol.h
    model/ip-l4-protocol.h
    model/ipv4-address-generator.h
    model/ipv4-end-point-demux.h
    model/ipv4-end-point.h
    model/global-routing.h
    model/ipv4-header.h
    model/ipv4-interface-address.h
    model/ipv4-interface.h
    model/ipv4-l3-protocol.h
    model/ipv4-list-routing.h
    model/ipv4-packet-filter.h
    model/ipv4-packet-info-tag.h
    model/ipv4-packet-probe.h
    model/ipv4-queue-disc-item.h
    model/ipv4-raw-socket-factory.h
    model/ipv4-raw-socket-impl.h
    model/ipv4-route.h
    model/ipv4-routing-protocol.h
    model/ipv4-routing-table-entry.h
    model/ipv4-static-routing.h
    model/ipv4.h
    model/ipv6-address-generator.h
    model/ipv6-end-point-demux.h
    model/ipv6-end-point.h
    model/ipv6-extension-demux.h
    model/ipv6-extension-header.h
    model/ipv6-extension.h
    model/ipv6-header.h
    model/ipv6-interface-address.h
    model/ipv6-interface.h
    model/ipv6-l3-protocol.h
    model/ipv6-list-routing.h
    model/ipv6-option-header.h
    model/ipv6-option.h
    model/ipv6-packet-filter.h
    model/ipv6-packet-info-tag.h
    model/ipv6-packet-probe.h
    model/ipv6-pmtu-cache.h
    model/ipv6-queue-disc-item.h
    model/ipv6-raw-socket-factory.h
    model/ipv6-route.h
    model/ipv6-routing-protocol.h
    model/ipv6-routing-table-entry.h
    model/ipv6-static-routing.h
    model/ipv6.h
    model/loopback-net-device.h
    model/ndisc-cache.h
    model/rip-header.h
    model/rip.h
    model/ripng-header.h
    model/ripng.h
    model/rtt-estimator.h
    model/tcp-bbr.h
    model/tcp-bic.h
    model/tcp-congestion-ops.h
    model/tcp-cubic.h
    model/tcp-dctcp.h
    model/tcp-header.h
    model/tcp-highspeed.h
    model/tcp-htcp.h
    model/tcp-hybla.h
    model/tcp-illinois.h
    model/tcp-l4-protocol.h
    model/tcp-ledbat.h
    model/tcp-linux-reno.h
    model/tcp-lp.h
    model/tcp-option-rfc793.h
    model/tcp-option-sack-permitted.h
    model/tcp-option-sack.h
    model/tcp-option-ts.h
    model/tcp-option-winscale.h
    model/tcp-option.h
    model/tcp-prr-recovery.h
    model/tcp-rate-ops.h
    model/tcp-recovery-ops.h
    model/tcp-rx-buffer.h
    model/tcp-scalable.h
    model/tcp-socket-base.h
    model/tcp-socket-factory.h
    model/tcp-socket-state.h
    model/tcp-socket.h
    model/tcp-tx-buffer.h
    model/tcp-tx-item.h
    model/tcp-vegas.h
    model/tcp-veno.h
    model/tcp-westwood-plus.h
    model/tcp-yeah.h
    model/udp-header.h
    model/udp-l4-protocol.h
    model/udp-socket-factory.h
    model/udp-socket.h
    model/windowed-filter.h
)

set(private_header_files)
if(WIN32)
  set(private_header_files
      model/win32-internet.h
  )
endif()

set(test_sources
    test/global-route-manager-impl-test-suite.cc
    test/icmp-test.cc
    test/internet-stack-helper-test-suite.cc
    test/ipv4-address-generator-test-suite.cc
    test/ipv4-address-helper-test-suite.cc
    test/ipv4-deduplication-test.cc
    test/ipv4-forwarding-test.cc
    test/ipv4-fragmentation-test.cc
    test/global-routing-test-suite.cc
    test/ipv4-header-test.cc
    test/ipv4-list-routing-test-suite.cc
    test/ipv4-packet-info-tag-test-suite.cc
    test/ipv4-raw-test.cc
    test/ipv4-rip-test.cc
    test/ipv4-static-routing-test-suite.cc
    test/ipv4-test.cc
    test/ipv6-address-duplication-test.cc
    test/ipv6-address-generator-test-suite.cc
    test/ipv6-address-helper-test-suite.cc
    test/ipv6-dual-stack-test-suite.cc
    test/ipv6-extension-header-test-suite.cc
    test/ipv6-forwarding-test.cc
    test/ipv6-fragmentation-test.cc
    test/ipv6-list-routing-test-suite.cc
    test/ipv6-packet-info-tag-test-suite.cc
    test/ipv6-raw-test.cc
    test/ipv6-ripng-test.cc
    test/ipv6-test.cc
    test/neighbor-cache-test.cc
    test/rtt-test.cc
    test/tcp-abe-test.cc
    test/tcp-advertised-window-test.cc
    test/tcp-bbr-test.cc
    test/tcp-bic-test.cc
    test/tcp-bytes-in-flight-test.cc
    test/tcp-classic-recovery-test.cc
    test/tcp-close-test.cc
    test/tcp-cong-avoid-test.cc
    test/tcp-datasentcb-test.cc
    test/tcp-dctcp-test.cc
    test/tcp-ecn-test.cc
    test/tcp-endpoint-bug2211.cc
    test/tcp-error-model.cc
    test/tcp-fack-test.cc
    test/tcp-fast-retr-test.cc
    test/tcp-general-test.cc
    test/tcp-header-test.cc
    test/tcp-highspeed-test.cc
    test/tcp-htcp-test.cc
    test/tcp-hybla-test.cc
    test/tcp-illinois-test.cc
    test/tcp-ledbat-test.cc
    test/tcp-linux-reno-test.cc
    test/tcp-loss-test.cc
    test/tcp-lp-test.cc
    test/tcp-option-test.cc
    test/tcp-pacing-test.cc
    test/tcp-pkts-acked-test.cc
    test/tcp-prr-recovery-test.cc
    test/tcp-rate-ops-test.cc
    test/tcp-rto-test.cc
    test/tcp-rtt-estimation.cc
    test/tcp-rx-buffer-test.cc
    test/tcp-sack-permitted-test.cc
    test/tcp-scalable-test.cc
    test/tcp-slow-start-test.cc
    test/tcp-syn-connection-failed-test.cc
    test/tcp-test.cc
    test/tcp-timestamp-test.cc
    test/tcp-tx-buffer-test.cc
    test/tcp-vegas-test.cc
    test/tcp-veno-test.cc
    test/tcp-wscaling-test.cc
    test/tcp-yeah-test.cc
    test/tcp-zero-window-test.cc
    test/udp-test.cc
)

build_lib(
  LIBNAME internet
  SOURCE_FILES ${source_files}
  HEADER_FILES ${header_files}
  PRIVATE_HEADER_FILES ${private_header_files}
  LIBRARIES_TO_LINK ${libbridge}
                    ${libtraffic-control}
  TEST_SOURCES ${test_sources}
  GENERATE_EXPORT_HEADER
)

=== src/lr-wpan/CMakeLists.txt ===
build_lib(
  LIBNAME lr-wpan
  SOURCE_FILES
    helper/lr-wpan-helper.cc
    model/lr-wpan-csmaca.cc
    model/lr-wpan-error-model.cc
    model/lr-wpan-fields.cc
    model/lr-wpan-interference-helper.cc
    model/lr-wpan-lqi-tag.cc
    model/lr-wpan-mac-header.cc
    model/lr-wpan-mac-pl-headers.cc
    model/lr-wpan-mac-trailer.cc
    model/lr-wpan-mac-base.cc
    model/lr-wpan-mac.cc
    model/lr-wpan-net-device.cc
    model/lr-wpan-phy.cc
    model/lr-wpan-spectrum-signal-parameters.cc
    model/lr-wpan-spectrum-value-helper.cc
  HEADER_FILES
    helper/lr-wpan-helper.h
    model/lr-wpan-constants.h
    model/lr-wpan-csmaca.h
    model/lr-wpan-error-model.h
    model/lr-wpan-fields.h
    model/lr-wpan-interference-helper.h
    model/lr-wpan-lqi-tag.h
    model/lr-wpan-mac-header.h
    model/lr-wpan-mac-pl-headers.h
    model/lr-wpan-mac-trailer.h
    model/lr-wpan-mac-base.h
    model/lr-wpan-mac.h
    model/lr-wpan-net-device.h
    model/lr-wpan-phy.h
    model/lr-wpan-spectrum-signal-parameters.h
    model/lr-wpan-spectrum-value-helper.h
  LIBRARIES_TO_LINK ${libspectrum}
  TEST_SOURCES
    test/lr-wpan-ack-test.cc
    test/lr-wpan-cca-test.cc
    test/lr-wpan-collision-test.cc
    test/lr-wpan-ed-test.cc
    test/lr-wpan-error-model-test.cc
    test/lr-wpan-packet-test.cc
    test/lr-wpan-phy-test.cc
    test/lr-wpan-spectrum-value-helper-test.cc
    test/lr-wpan-ifs-test.cc
    test/lr-wpan-slotted-csmaca-test.cc
    test/lr-wpan-mac-test.cc
)

=== src/network/CMakeLists.txt ===
set(source_files
    helper/application-container.cc
    helper/application-helper.cc
    helper/delay-jitter-estimation.cc
    helper/net-device-container.cc
    helper/node-container.cc
    helper/packet-socket-helper.cc
    helper/simple-net-device-helper.cc
    helper/trace-helper.cc
    model/address.cc
    model/application.cc
    model/buffer.cc
    model/byte-tag-list.cc
    model/channel-list.cc
    model/channel.cc
    model/chunk.cc
    model/header.cc
    model/net-device.cc
    model/nix-vector.cc
    model/node-list.cc
    model/node.cc
    model/packet-metadata.cc
    model/packet-tag-list.cc
    model/packet.cc
    model/socket-factory.cc
    model/socket.cc
    model/tag-buffer.cc
    model/tag.cc
    model/trailer.cc
    utils/address-utils.cc
    utils/bit-deserializer.cc
    utils/bit-serializer.cc
    utils/crc32.cc
    utils/data-rate.cc
    utils/drop-tail-queue.cc
    utils/dynamic-queue-limits.cc
    utils/error-channel.cc
    utils/error-model.cc
    utils/ethernet-header.cc
    utils/ethernet-trailer.cc
    utils/flow-id-tag.cc
    utils/inet-socket-address.cc
    utils/inet6-socket-address.cc
    utils/ipv4-address.cc
    utils/ipv6-address.cc
    utils/llc-snap-header.cc
    utils/mac16-address.cc
    utils/mac48-address.cc
    utils/mac64-address.cc
    utils/mac8-address.cc
    utils/net-device-queue-interface.cc
    utils/output-stream-wrapper.cc
    utils/packet-burst.cc
    utils/packet-data-calculators.cc
    utils/packet-probe.cc
    utils/packet-socket-address.cc
    utils/packet-socket-client.cc
    utils/packet-socket-factory.cc
    utils/packet-socket-server.cc
    utils/packet-socket.cc
    utils/packetbb.cc
    utils/pcap-file-wrapper.cc
    utils/pcap-file.cc
    utils/queue-item.cc
    utils/queue-limits.cc
    utils/queue-size.cc
    utils/queue.cc
    utils/radiotap-header.cc
    utils/simple-channel.cc
    utils/simple-net-device.cc
    utils/sll-header.cc
    utils/timestamp-tag.cc
)

set(header_files
    helper/application-container.h
    helper/application-helper.h
    helper/delay-jitter-estimation.h
    helper/net-device-container.h
    helper/node-container.h
    helper/packet-socket-helper.h
    helper/simple-net-device-helper.h
    helper/trace-helper.h
    model/address.h
    model/application.h
    model/buffer.h
    model/byte-tag-list.h
    model/channel-list.h
    model/channel.h
    model/chunk.h
    model/header.h
    model/net-device.h
    model/nix-vector.h
    model/node-list.h
    model/node.h
    model/packet-metadata.h
    model/packet-tag-list.h
    model/packet.h
    model/socket-factory.h
    model/socket.h
    model/tag-buffer.h
    model/tag.h
    model/trailer.h
    utils/address-utils.h
    utils/bit-deserializer.h
    utils/bit-serializer.h
    utils/crc32.h
    utils/data-rate.h
    utils/drop-tail-queue.h
    utils/dynamic-queue-limits.h
    utils/error-channel.h
    utils/error-model.h
    utils/ethernet-header.h
    utils/ethernet-trailer.h
    utils/flow-id-tag.h
    utils/generic-phy.h
    utils/header-serialization-test.h
    utils/inet-socket-address.h
    utils/inet6-socket-address.h
    utils/ipv4-address.h
    utils/ipv6-address.h
    utils/llc-snap-header.h
    utils/lollipop-counter.h
    utils/mac16-address.h
    utils/mac48-address.h
    utils/mac64-address.h
    utils/mac8-address.h
    utils/net-device-queue-interface.h
    utils/output-stream-wrapper.h
    utils/packet-burst.h
    utils/packet-data-calculators.h
    utils/packet-probe.h
    utils/packet-socket-address.h
    utils/packet-socket-client.h
    utils/packet-socket-factory.h
    utils/packet-socket-server.h
    utils/packet-socket.h
    utils/packetbb.h
    utils/pcap-file-wrapper.h
    utils/pcap-file.h
    utils/pcap-test.h
    utils/queue-fwd.h
    utils/queue-item.h
    utils/queue-limits.h
    utils/queue-size.h
    utils/queue.h
    utils/radiotap-header.h
    utils/sequence-number.h
    utils/simple-channel.h
    utils/simple-net-device.h
    utils/sll-header.h
    utils/timestamp-tag.h
)

build_lib(
  LIBNAME network
  SOURCE_FILES ${source_files}
  HEADER_FILES ${header_files}
  LIBRARIES_TO_LINK ${libstats}
  TEST_SOURCES
    test/address-test.cc
    test/bit-serializer-test.cc
    test/buffer-test.cc
    test/drop-tail-queue-test-suite.cc
    test/error-model-test-suite.cc
    test/ipv6-address-test-suite.cc
    test/lollipop-counter-test.cc
    test/packet-metadata-test.cc
    test/packet-socket-apps-test-suite.cc
    test/packet-test-suite.cc
    test/packetbb-test-suite.cc
    test/pcap-file-test-suite.cc
    test/sequence-number-test-suite.cc
    test/test-data-rate.cc
)

=== src/openflow/CMakeLists.txt ===
set(NS3_WITH_OPENFLOW
    ""
    CACHE PATH
          "Build with Openflow support"
)
set(NS3_OPENFLOW
    "OFF"
    CACHE INTERNAL
          "ON if Openflow is found in NS3_WITH_OPENFLOW"
)

find_external_library(
  DEPENDENCY_NAME openflow
  HEADER_NAME openflow.h
  LIBRARY_NAME openflow
  SEARCH_PATHS ${NS3_WITH_OPENFLOW}
  OUTPUT_VARIABLE "NS3_OPENFLOW_REASON"
)

if((NOT
    openflow_FOUND)
   AND (NOT
        ${openflow_FOUND})
   AND (NOT
        ${NS3_FETCH_OPTIONAL_COMPONENTS})
)
  message(
    ${HIGHLIGHTED_STATUS}
    "Skipping src/openflow"
  )
  return()
endif()

if(${NS3_FETCH_OPTIONAL_COMPONENTS})
  set(openflow_LIBRARIES
      openflow
  )
endif()

check_include_file_cxx(
  boost/static_assert.hpp
  BOOST_STATIC_ASSERT
)
if(NOT
   BOOST_STATIC_ASSERT
)
  message(STATUS "Openflow requires Boost static_assert.hpp")
  return()
endif()

include_directories(
  SYSTEM
  ${openflow_INCLUDE_DIRS}
)
add_definitions(
  -DNS3_OPENFLOW
  -DENABLE_OPENFLOW
)
set(NS3_OPENFLOW
    "ON"
    CACHE INTERNAL
          "ON if Openflow is found in NS3_WITH_OPENFLOW"
)

if(${GCC})
  add_compile_options(-Wno-stringop-truncation) # This option does not exist in
                                                # CLANG
elseif(${CLANG})
  add_compile_options(-Wno-reserved-user-defined-literal)
endif()

build_lib(
  LIBNAME openflow
  SOURCE_FILES
    helper/openflow-switch-helper.cc
    model/openflow-interface.cc
    model/openflow-switch-net-device.cc
  HEADER_FILES
    helper/openflow-switch-helper.h
    model/openflow-interface.h
    model/openflow-switch-net-device.h
  LIBRARIES_TO_LINK ${libinternet}
                    ${openflow_LIBRARIES}
  TEST_SOURCES test/openflow-switch-test-suite.cc
)

=== src/visualizer/CMakeLists.txt ===
# Embedding python isn't a good option, so just leave symbols undefined and hope
# for the best https://github.com/pypa/manylinux/pull/1185
# https://github.com/scikit-build/scikit-build/pull/47
# https://9to5answer.com/can-gcc-not-complain-about-undefined-references
set(python_libraries
    ${Python3_LIBRARIES}
)
if(${NS3_PIP_PACKAGING})
  set(python_libraries
      -Wl,--allow-shlib-undefined
  )
endif()

build_lib(
  LIBNAME visualizer
  SOURCE_FILES
    model/fast-clipping.cc
    model/pyviz.cc
    model/visual-simulator-impl.cc
  HEADER_FILES model/fast-clipping.h
               model/pyviz.h
  LIBRARIES_TO_LINK
    ${python_libraries}
    ${libinternet}
    ${libwifi}
    ${liblr-wpan}
    ${libpoint-to-point}
)

# move visualizer folder to build/bindings/python, which allows us to add only
# PYTHONPATH=ns-3-dev/build/bindings/python
file(
  GLOB_RECURSE
  visualizer_files
  ${CMAKE_CURRENT_SOURCE_DIR}/visualizer/*
)
foreach(
  file
  ${visualizer_files}
)
  string(
    REPLACE "${CMAKE_CURRENT_SOURCE_DIR}"
            "${CMAKE_OUTPUT_DIRECTORY}/bindings/python"
            destination
            ${file}
  )
  configure_file(
    ${file}
    ${destination}
    COPYONLY
  )
endforeach()

if(NOT
   NS3_BINDINGS_INSTALL_DIR
)
  message(
    ${HIGHLIGHTED_STATUS}
    "NS3_BINDINGS_INSTALL_DIR was not set. The visualizer python module won't be installed with ./ns3 install."
  )
else()
  install(
    DIRECTORY ./visualizer
    DESTINATION ${NS3_BINDINGS_INSTALL_DIR}/
  )

  add_custom_target(
    uninstall_visualizer
    COMMAND rm -R ${NS3_BINDINGS_INSTALL_DIR}/visualizer
  )
  add_dependencies(
    uninstall
    uninstall_visualizer
  )
endif()

=== src/wifi/CMakeLists.txt ===
set(gsl_libraries)
if(${GSL_FOUND})
  set(gsl_libraries
      ${GSL_LIBRARIES}
  )
endif()

set(source_files
    helper/athstats-helper.cc
    helper/spectrum-wifi-helper.cc
    helper/wifi-co-trace-helper.cc
    helper/wifi-helper.cc
    helper/wifi-mac-helper.cc
    helper/wifi-radio-energy-model-helper.cc
    helper/yans-wifi-helper.cc
    helper/wifi-phy-rx-trace-helper.cc
    helper/wifi-static-setup-helper.cc
    helper/wifi-tx-stats-helper.cc
    model/addba-extension.cc
    model/adhoc-wifi-mac.cc
    model/ampdu-subframe-header.cc
    model/ampdu-tag.cc
    model/amsdu-subframe-header.cc
    model/ap-wifi-mac.cc
    model/block-ack-agreement.cc
    model/block-ack-manager.cc
    model/block-ack-type.cc
    model/block-ack-window.cc
    model/capability-information.cc
    model/channel-access-manager.cc
    model/ctrl-headers.cc
    model/edca-parameter-set.cc
    model/eht/advanced-ap-emlsr-manager.cc
    model/eht/advanced-emlsr-manager.cc
    model/eht/ap-emlsr-manager.cc
    model/eht/advanced-ap-emlsr-manager.cc
    model/eht/common-info-basic-mle.cc
    model/eht/common-info-probe-req-mle.cc
    model/eht/default-ap-emlsr-manager.cc
    model/eht/default-emlsr-manager.cc
    model/eht/eht-capabilities.cc
    model/eht/eht-configuration.cc
    model/eht/eht-frame-exchange-manager.cc
    model/eht/eht-operation.cc
    model/eht/tid-to-link-mapping-element.cc
    model/eht/eht-phy.cc
    model/eht/eht-ppdu.cc
    model/eht/eht-ru.cc
    model/eht/emlsr-manager.cc
    model/eht/multi-link-element.cc
    model/error-rate-model.cc
    model/extended-capabilities.cc
    model/fcfs-wifi-queue-scheduler.cc
    model/frame-capture-model.cc
    model/frame-exchange-manager.cc
    model/gcr-group-address.cc
    model/gcr-manager.cc
    model/he/constant-obss-pd-algorithm.cc
    model/he/he-6ghz-band-capabilities.cc
    model/he/he-capabilities.cc
    model/he/he-configuration.cc
    model/he/he-frame-exchange-manager.cc
    model/he/he-operation.cc
    model/he/he-phy.cc
    model/he/he-ppdu.cc
    model/he/he-ru.cc
    model/he/mu-edca-parameter-set.cc
    model/he/mu-snr-tag.cc
    model/he/multi-user-scheduler.cc
    model/he/obss-pd-algorithm.cc
    model/he/rr-multi-user-scheduler.cc
    model/ht/ht-capabilities.cc
    model/ht/ht-configuration.cc
    model/ht/ht-frame-exchange-manager.cc
    model/ht/ht-operation.cc
    model/ht/ht-phy.cc
    model/ht/ht-ppdu.cc
    model/interference-helper.cc
    model/mac-rx-middle.cc
    model/mac-tx-middle.cc
    model/mgt-action-headers.cc
    model/mgt-headers.cc
    model/mpdu-aggregator.cc
    model/msdu-aggregator.cc
    model/nist-error-rate-model.cc
    model/non-ht/dsss-error-rate-model.cc
    model/non-ht/dsss-parameter-set.cc
    model/non-ht/dsss-phy.cc
    model/non-ht/dsss-ppdu.cc
    model/non-ht/erp-information.cc
    model/non-ht/erp-ofdm-phy.cc
    model/non-ht/erp-ofdm-ppdu.cc
    model/non-ht/ofdm-phy.cc
    model/non-ht/ofdm-ppdu.cc
    model/non-inheritance.cc
    model/originator-block-ack-agreement.cc
    model/phy-entity.cc
    model/preamble-detection-model.cc
    model/qos-frame-exchange-manager.cc
    model/qos-txop.cc
    model/qos-utils.cc
    model/rate-control/aarf-wifi-manager.cc
    model/rate-control/aarfcd-wifi-manager.cc
    model/rate-control/amrr-wifi-manager.cc
    model/rate-control/aparf-wifi-manager.cc
    model/rate-control/arf-wifi-manager.cc
    model/rate-control/cara-wifi-manager.cc
    model/rate-control/constant-rate-wifi-manager.cc
    model/rate-control/ideal-wifi-manager.cc
    model/rate-control/minstrel-ht-wifi-manager.cc
    model/rate-control/minstrel-wifi-manager.cc
    model/rate-control/onoe-wifi-manager.cc
    model/rate-control/parf-wifi-manager.cc
    model/rate-control/rraa-wifi-manager.cc
    model/rate-control/rrpaa-wifi-manager.cc
    model/rate-control/thompson-sampling-wifi-manager.cc
    model/recipient-block-ack-agreement.cc
    model/reduced-neighbor-report.cc
    model/reference/error-rate-tables.cc
    model/simple-frame-capture-model.cc
    model/snr-tag.cc
    model/spectrum-wifi-phy.cc
    model/ssid.cc
    model/sta-wifi-mac.cc
    model/status-code.cc
    model/supported-rates.cc
    model/table-based-error-rate-model.cc
    model/threshold-preamble-detection-model.cc
    model/tim.cc
    model/txop.cc
    model/vht/vht-capabilities.cc
    model/vht/vht-configuration.cc
    model/vht/vht-frame-exchange-manager.cc
    model/vht/vht-operation.cc
    model/vht/vht-phy.cc
    model/vht/vht-ppdu.cc
    model/wifi-ack-manager.cc
    model/wifi-acknowledgment.cc
    model/wifi-assoc-manager.cc
    model/wifi-bandwidth-filter.cc
    model/wifi-default-ack-manager.cc
    model/wifi-default-assoc-manager.cc
    model/wifi-default-gcr-manager.cc
    model/wifi-default-protection-manager.cc
    model/wifi-information-element.cc
    model/wifi-mac-header.cc
    model/wifi-mac-queue-container.cc
    model/wifi-mac-queue-elem.cc
    model/wifi-mac-queue-scheduler.cc
    model/wifi-mac-queue.cc
    model/wifi-mac-trailer.cc
    model/wifi-mac.cc
    model/wifi-mode.cc
    model/wifi-mpdu.cc
    model/wifi-net-device.cc
    model/wifi-phy.cc
    model/wifi-phy-common.cc
    model/wifi-phy-operating-channel.cc
    model/wifi-phy-state-helper.cc
    model/wifi-ppdu.cc
    model/wifi-protection-manager.cc
    model/wifi-protection.cc
    model/wifi-psdu.cc
    model/wifi-radio-energy-model.cc
    model/wifi-remote-station-info.cc
    model/wifi-remote-station-manager.cc
    model/wifi-ru.cc
    model/wifi-spectrum-phy-interface.cc
    model/wifi-spectrum-signal-parameters.cc
    model/wifi-standards.cc
    model/wifi-tx-current-model.cc
    model/wifi-tx-parameters.cc
    model/wifi-tx-timer.cc
    model/wifi-tx-vector.cc
    model/wifi-types.cc
    model/wifi-utils.cc
    model/yans-error-rate-model.cc
    model/yans-wifi-channel.cc
    model/yans-wifi-phy.cc
    model/wifi-spectrum-value-helper.cc
)

set(header_files
    helper/athstats-helper.h
    helper/spectrum-wifi-helper.h
    helper/wifi-co-trace-helper.h
    helper/wifi-helper.h
    helper/wifi-mac-helper.h
    helper/wifi-radio-energy-model-helper.h
    helper/yans-wifi-helper.h
    helper/wifi-phy-rx-trace-helper.h
    helper/wifi-static-setup-helper.h
    helper/wifi-tx-stats-helper.h
    model/addba-extension.h
    model/adhoc-wifi-mac.h
    model/ampdu-subframe-header.h
    model/ampdu-tag.h
    model/amsdu-subframe-header.h
    model/ap-wifi-mac.h
    model/block-ack-agreement.h
    model/block-ack-manager.h
    model/block-ack-type.h
    model/block-ack-window.h
    model/capability-information.h
    model/channel-access-manager.h
    model/ctrl-headers.h
    model/edca-parameter-set.h
    model/eht/advanced-ap-emlsr-manager.h
    model/eht/advanced-emlsr-manager.h
    model/eht/ap-emlsr-manager.h
    model/eht/common-info-basic-mle.h
    model/eht/common-info-probe-req-mle.h
    model/eht/default-ap-emlsr-manager.h
    model/eht/default-emlsr-manager.h
    model/eht/eht-capabilities.h
    model/eht/eht-configuration.h
    model/eht/eht-frame-exchange-manager.h
    model/eht/eht-operation.h
    model/eht/tid-to-link-mapping-element.h
    model/eht/eht-phy.h
    model/eht/eht-ppdu.h
    model/eht/eht-ru.h
    model/eht/emlsr-manager.h
    model/eht/multi-link-element.h
    model/error-rate-model.h
    model/extended-capabilities.h
    model/fcfs-wifi-queue-scheduler.h
    model/frame-capture-model.h
    model/frame-exchange-manager.h
    model/gcr-group-address.h
    model/gcr-manager.h
    model/he/constant-obss-pd-algorithm.h
    model/he/he-6ghz-band-capabilities.h
    model/he/he-capabilities.h
    model/he/he-configuration.h
    model/he/he-frame-exchange-manager.h
    model/he/he-operation.h
    model/he/he-phy.h
    model/he/he-ppdu.h
    model/he/he-ru.h
    model/he/mu-edca-parameter-set.h
    model/he/mu-snr-tag.h
    model/he/multi-user-scheduler.h
    model/he/obss-pd-algorithm.h
    model/he/rr-multi-user-scheduler.h
    model/ht/ht-capabilities.h
    model/ht/ht-configuration.h
    model/ht/ht-frame-exchange-manager.h
    model/ht/ht-operation.h
    model/ht/ht-phy.h
    model/ht/ht-ppdu.h
    model/interference-helper.h
    model/mac-rx-middle.h
    model/mac-tx-middle.h
    model/mgt-action-headers.h
    model/mgt-headers.h
    model/mpdu-aggregator.h
    model/msdu-aggregator.h
    model/nist-error-rate-model.h
    model/non-ht/dsss-error-rate-model.h
    model/non-ht/dsss-parameter-set.h
    model/non-ht/dsss-phy.h
    model/non-ht/dsss-ppdu.h
    model/non-ht/erp-information.h
    model/non-ht/erp-ofdm-phy.h
    model/non-ht/erp-ofdm-ppdu.h
    model/non-ht/ofdm-phy.h
    model/non-ht/ofdm-ppdu.h
    model/non-inheritance.h
    model/originator-block-ack-agreement.h
    model/phy-entity.h
    model/preamble-detection-model.h
    model/qos-frame-exchange-manager.h
    model/qos-txop.h
    model/qos-utils.h
    model/rate-control/aarf-wifi-manager.h
    model/rate-control/aarfcd-wifi-manager.h
    model/rate-control/amrr-wifi-manager.h
    model/rate-control/aparf-wifi-manager.h
    model/rate-control/arf-wifi-manager.h
    model/rate-control/cara-wifi-manager.h
    model/rate-control/constant-rate-wifi-manager.h
    model/rate-control/ideal-wifi-manager.h
    model/rate-control/minstrel-ht-wifi-manager.h
    model/rate-control/minstrel-wifi-manager.h
    model/rate-control/onoe-wifi-manager.h
    model/rate-control/parf-wifi-manager.h
    model/rate-control/rraa-wifi-manager.h
    model/rate-control/rrpaa-wifi-manager.h
    model/rate-control/thompson-sampling-wifi-manager.h
    model/recipient-block-ack-agreement.h
    model/reduced-neighbor-report.h
    model/reference/error-rate-tables.h
    model/simple-frame-capture-model.h
    model/snr-tag.h
    model/spectrum-wifi-phy.h
    model/ssid.h
    model/sta-wifi-mac.h
    model/status-code.h
    model/supported-rates.h
    model/table-based-error-rate-model.h
    model/threshold-preamble-detection-model.h
    model/tim.h
    model/txop.h
    model/vht/vht-capabilities.h
    model/vht/vht-configuration.h
    model/vht/vht-frame-exchange-manager.h
    model/vht/vht-operation.h
    model/vht/vht-phy.h
    model/vht/vht-ppdu.h
    model/wifi-ack-manager.h
    model/wifi-acknowledgment.h
    model/wifi-assoc-manager.h
    model/wifi-bandwidth-filter.h
    model/wifi-default-ack-manager.h
    model/wifi-default-assoc-manager.h
    model/wifi-default-gcr-manager.h
    model/wifi-default-protection-manager.h
    model/wifi-information-element.h
    model/wifi-mac-header.h
    model/wifi-mac-queue-container.h
    model/wifi-mac-queue-elem.h
    model/wifi-mac-queue-scheduler-impl.h
    model/wifi-mac-queue-scheduler.h
    model/wifi-mac-queue.h
    model/wifi-mac-trailer.h
    model/wifi-mac.h
    model/wifi-mgt-header.h
    model/wifi-mode.h
    model/wifi-mpdu.h
    model/wifi-net-device.h
    model/wifi-ns3-constants.h
    model/wifi-opt-field.h
    model/wifi-phy-band.h
    model/wifi-phy-common.h
    model/wifi-phy-listener.h
    model/wifi-phy-operating-channel.h
    model/wifi-phy-state-helper.h
    model/wifi-phy-state.h
    model/wifi-phy.h
    model/wifi-ppdu.h
    model/wifi-protection-manager.h
    model/wifi-protection.h
    model/wifi-psdu.h
    model/wifi-radio-energy-model.h
    model/wifi-remote-station-info.h
    model/wifi-remote-station-manager.h
    model/wifi-ru.h
    model/wifi-spectrum-phy-interface.h
    model/wifi-spectrum-signal-parameters.h
    model/wifi-standard-constants.h
    model/wifi-standards.h
    model/wifi-tx-current-model.h
    model/wifi-tx-parameters.h
    model/wifi-tx-timer.h
    model/wifi-tx-vector.h
    model/wifi-types.h
    model/wifi-units.h
    model/wifi-utils.h
    model/yans-error-rate-model.h
    model/yans-wifi-channel.h
    model/yans-wifi-phy.h
    model/wifi-spectrum-value-helper.h
    test/wifi-mlo-test.h
)

build_lib(
  LIBNAME wifi
  SOURCE_FILES ${source_files}
  HEADER_FILES ${header_files}
  LIBRARIES_TO_LINK
    ${libenergy}
    ${libspectrum}
    ${gsl_libraries}

=== debian/changelog ===
ns3 (3.47-1) unstable; urgency=medium

  * New upstream release.

 -- Martin Quinson <mquinson@debian.org>  Mon, 23 Feb 2026 22:28:01 +0100

=== debian/control ===
Source: ns3
Section: net
Priority: optional
Standards-Version: 4.7.2
Maintainer: Martin Quinson <mquinson@debian.org>
Uploaders:
 YunQiang Su <syq@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-exec (>= 0.13),
 dh-python,
 bison,
 cmake,
 dpkg (>= 1.16.1),
 flex,
 gir1.2-gtk-3.0,
 ipython3,
# jdupes,
 libboost-filesystem-dev,
 libgraphviz-dev,
 libgsl-dev,
 libsqlite3-dev,
 libxml2-dev,
 pkgconf,
 python3-dev,
 python3-gi,
 python3-gi-cairo,
 python3-pygraphviz,
 quilt (>= 0.46-7~),
#Build-Depends-Indep:
# dia,
# doxygen,
# dvipng,
# ghostscript,
# imagemagick,
# latexmk,
# python3-sphinx,
# tex-gyre,
# texlive-font-utils,
# texlive-latex-extra,
# texlive-latex-base,
# texlive-latex-recommended,
Build-Conflicts:
 libmpich2-dev,
Vcs-Browser: https://salsa.debian.org/debian/ns3
Homepage: https://www.nsnam.org/
Vcs-Git: https://salsa.debian.org/debian/ns3.git

Package: ns3
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: discrete-event network simulator for Internet systems
 ns-3 is a discrete-event network simulator for Internet systems,
 targeted primarily for research and educational use.
 ns-3 is free software, licensed under the GNU GPLv2 license,
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives
 historically from the concatenation of ns (network simulator)
 and NAM (network animator).
 .
 This package contains several utilities. The files for development
 are in libns3-3, libns3-dev and python3-ns3.

# Package: ns3-doc
# Architecture: all
# Build-Profiles: <!nodoc>
# Multi-Arch: foreign
# Depends: ${shlibs:Depends}, ${misc:Depends}, libjs-jquery, libjs-sphinxdoc
# Section: doc
# Description: documentation for ns-3
#  ns-3 is a discrete-event network simulator for Internet systems,
#  targeted primarily for research and educational use.
#  ns-3 is free software, licensed under the GNU GPLv2 license,
#  and is publicly available for research, development, and use.
#  ns-3 is intended as an eventual replacement for the popular
#  ns-2 simulator. The project acronym “nsnam” derives
#  historically from the concatenation of ns (network simulator)
#  and NAM (network animator).
#  .
#  This package contains manual, modules, tutorial and doxygen.

Package: libns3-dev
Architecture: any
Depends:
 g++,
 libns3.47 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 ns3 (= 3.25+dfsg2-2),
Section: libdevel
Description: Static and header files of ns-3
 ns-3 is a discrete-event network simulator for Internet systems,
 targeted primarily for research and educational use.
 ns-3 is free software, licensed under the GNU GPLv2 license,
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives
 historically from the concatenation of ns (network simulator)
 and NAM (network animator).
 .
 This package contains static libraries, header files.

# Note to self: when updating this, you also need to update the SONAME in the relevant patch
Package: libns3.47
Provides:
 ${t64:Provides},
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Section: libs
Description: shared libraries of ns-3
 ns-3 is a discrete-event network simulator for Internet systems,
 targeted primarily for research and educational use.
 ns-3 is free software, licensed under the GNU GPLv2 license,
 and is publicly available for research, development, and use.
 ns-3 is intended as an eventual replacement for the popular
 ns-2 simulator. The project acronym “nsnam” derives
 historically from the concatenation of ns (network simulator)
 and NAM (network animator).
 .
 This package contains shared libraries.

#Package: python3-ns3
#Architecture: any
#Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
#  python3-pygraphviz
#Section: python
#Suggests: tcpdump
#Breaks: python-ns3
#Description: Python binding of ns3
# ns-3 is a discrete-event network simulator for Internet systems,
# targeted primarily for research and educational use.
# ns-3 is free software, licensed under the GNU GPLv2 license,
# and is publicly available for research, development, and use.
# ns-3 is intended as an eventual replacement for the popular
# ns-2 simulator. The project acronym “nsnam” derives
# historically from the concatenation of ns (network simulator)
# and NAM (network animator).
# .
# This package contains Python binding of ns3.
